import pandas as pd

# 读取 Excel 文件
input_file = r"C:\Users\16142\Desktop\水稳匹配原样品编码.xlsx" # 输入水稳已匹配原编码表
output_file =r"C:\Users\16142\Desktop\水稳样品清洗重复平行项.xlsx"  # 输出文件路径
df = pd.read_excel(input_file)

# 需要取平均值的列
columns_to_average = [
    '水稳>5mm（%）',
    '水稳3mm~5mm（%）',
    '水稳2mm~3mm（%）',
    '水稳1mm~2mm（%）',
    '水稳0.5mm~1mm（%）',
    '水稳0.25mm~0.5mm（%）',
    '水稳性大团聚体总和（%）'
]

# 按"原样品编号"分组，计算每组的平均值
df_avg = df.groupby('原样品编号', as_index=False)[columns_to_average].mean()
df_avg['原样品编号'] = df_avg['原样品编号'].astype(str)
# 保存结果到新的 Excel 文件
df_avg.to_excel(output_file, index=False)

print(f"处理完成，结果已保存到 {output_file}")
